/***************************************************************************
    copyright            : (C) 2009 by Abdulhaq Lynch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; Version 2 of the License.               *
 *                                                                         *
 ***************************************************************************/


#include "kprayertimeconfig.h"
#include "prayconst.h"
#include "prayer.h"

#ifndef CALCTIME_H
#define CALCTIME_H

class CalcTime
{

private:

  int TZR; // time zone region

  int m_error_corr_min;
  int m_error_clock_min;
  int m_zawaal_min;

public:

  CalcTime();

  void loadConfig(KPrayerTimeConfig & config);
  void setMethod(int itlMethod);
  void setPosition(double latitude, double longitude, int altitude);
  void setTimeZone(float tz);
  void setErrorCorrection(int errorCorrMin, int errorClockMin);
  void setZawaal(int zawaal);
  void setDate(QDate date);
  void setDST(bool dst);
  void accountForErrors();
  void accountForDST();

  void initCalc(void);
  void makeSchedule();
  void makeScheduleTomorrow();

  int deg, min, sec;

  Location m_location;
  int m_method_type;
  Method m_method;
  Date m_date;
  bool m_dst;

  Prayer m_prayer_times[6];
  Prayer m_next_fajr;

  void calc();

} ;

#endif
