/***************************************************************************
    copyright            : (C) 2009 by Abdulhaq Lynch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; Version 2 of the License.               *
 *                                                                         *
 ***************************************************************************/

#ifndef PAINTWIDGET_H
#define PAINTWIDGET_H

#include <QWidget>
#include <QPaintEvent>
#include <QTimer>
#include "prayer.h"
#include "painter.h"
#include "config.h"
#include "kprayertimeconfig.h"

enum Mode {NORMAL, ANIMATE};

class PaintWidget : public QWidget
{
    Q_OBJECT

public:
    PaintWidget();

    void paintEvent(QPaintEvent * event);
    void mousePressEvent(QMouseEvent * event);
    void paint();

  private:
    void toggleAnimate();
    void makeSchedule(QDate date);
    void contextMenuEvent(QContextMenuEvent * event);

    QTimer timer;
    Prayer * m_schedule;
    Painter * m_painter;
    CalcTime m_calc_time;
    int m_last_minute;
    Mode m_mode;
    int m_animate_hour, m_animate_minute;
    KPrayerTimeConfig * m_config;
    ConfigDialog * m_config_dialog;
    bool m_config_changed;

  public slots:
    void timer_fired();
    void show_configuration();

};

#endif // PAINTWIDGET_H
